import { Observer } from './observer';
import { fdObject } from './fdObject';

/**
 *
 * @param arr Array of observer
 * @param results function for calculate
 */
export function composite(
  arr: Array<Observer<any> | fdObject<any>>,
  results: (...args: any[]) => any,
): Observer<any> {
  if (arr.length === 0) {
    return;
  }

  const getValue = (list: Array<Observer<any> | fdObject<any>>) => {
    return results(...list.map(e => e.value));
  };

  const initValue = getValue(arr);
  const resultsObs = new Observer(initValue);

  arr.forEach(item => {
    if (item instanceof Observer) {
      item.addSubscriber(() => {
        resultsObs.value = getValue(arr);
      });
    } else {
      item.observer.addSubscriber(() => {
        resultsObs.value = getValue(arr);
      });
    }
  });

  return resultsObs;
}
